function ButtonTrackingObj(exp, titleName, cm, frame){
   this.VarTrivBtnTracking = new Variable( 'VarTrivBtnTracking', null, 0, cm, frame, exp, titleName, true );
   this.title = null;
}

ButtonTrackingObj.codeToStateMap =
{
	'N' : 'normalState',
	'O' : 'overState',
	'D' : 'downState',
	'A' : 'disabledState',
	'V' : 'visitedState',
	'S' : 'selectedState'
};
ButtonTrackingObj.stateToCodeMap = {};
for (var key in ButtonTrackingObj.codeToStateMap)
	ButtonTrackingObj.stateToCodeMap[ButtonTrackingObj.codeToStateMap[key]] = key;

ButtonTrackingObj.prototype.InitPageTracking = function ( )
{
	var THIS = this;
	var pageTrackData = this.VarTrivBtnTracking.getValue();
	var bDoInit = true;
	try {
	    if (pageTrackData && pageTrackData.length > 0 && pageTrackData != '~~~null~~~')
	    {
	        var topLevelSplit = pageTrackData.split('#');
	        if (topLevelSplit && topLevelSplit.length > 1)
            {
		        var arrIds = topLevelSplit[0].split(',');
		        var arrStatus = topLevelSplit[1].split(',');
		        for( var i=0; i<arrIds.length; i++ )
		        {
			        var id = parseInt( '0x' + arrIds[i] );
			        var status = arrStatus[i];
			        var node = this.FindNode( this.title, id );
			        if( node )
						node.v = ButtonTrackingObj.codeToStateMap[status] || status;
		        }
    		}
        }
    } catch (e) { }
}

ButtonTrackingObj.prototype.FindNode = function( node, id )
{
	if( node.id == id )
		return node;
	
	var match = null;
	if( typeof( node.c ) != 'undefined' ){
		for( var i=0; i<node.c.length; i++ ){
			match = this.FindNode( node.c[i], id );
			if( match != null )
				break;
		}
	}
	
	return match;
}

ButtonTrackingObj.prototype.InternalGetRangeStatus = function( node )
{
	if( node == null )
		return -1;
		
	if( typeof(node.c) == 'undefined' )
	{
		return node.v;
	}
	else
	{
		return 'normalState';
	}
}


ButtonTrackingObj.prototype.GetRangeStatus = function( id, bInit )
{
	var status = -1;
	if ( bInit ) 
		this.InitPageTracking();
	
	status = this.InternalGetRangeStatus( this.FindNode( this.title, id ) );

	return status;
}


ButtonTrackingObj.prototype.InternalSetRangeStatus=function( node, status )
{
	if( node == null )
		return;
	node.v = status;
	if( status == 0 && typeof(node.c)!='undefined')
	{
		for( var i=0; i<node.c.length; i++ )
			this.InternalSetRangeStatus( node.c[i], status ); 
	}
}

ButtonTrackingObj.prototype.SetRangeStatus = function( id, status /*0 or 1 or 2*/)
{
	this.InternalSetRangeStatus( this.FindNode(this.title, id), status );
	
	this.SavePageTracking();
}

ButtonTrackingObj.prototype.IterateTree = function( func )
{
	var stack = [];
	stack.push( this.title );
	var i = 0;
	while( stack.length > 0 )
	{
		var node = stack.shift();
		
		if( typeof(node.c) != 'undefined' )
			stack = node.c.concat(stack);
			
		//do the thing
		func( node, i, stack );
		i++;
	}	
}

ButtonTrackingObj.prototype.SavePageTracking = function()
{
	var fnIsSaveState = window.ObjButton && ObjButton.isSaveState || function () { return false; };
	var hexString = '';
	var arrayIds = [];
	var arrayStatus= [];
	
	this.IterateTree(function(node, i, stack){
		if (fnIsSaveState(node.v))
		{
			arrayIds.push(node.id);
			arrayStatus.push(node.v);
		}
	});
	
	for( var i=0; i<arrayIds.length; i++ )
		hexString += (i > 0 ? ',' : '') + arrayIds[i].toString(16);

	hexString += (arrayIds.length > 0 ? '#' : '');
	
	for (var i = 0; i < arrayStatus.length; i++)
		hexString += (i > 0 ? ',' : '') + (ButtonTrackingObj.stateToCodeMap[arrayStatus[i]] || arrayStatus[i]);

	//LD-8267 - Added a condition to avoid tracking null/empty data unnecessarily
	if (hexString.length > 0 || (myTop.suspendDataCache && myTop.suspendDataCache.indexOf('VarTrivBtnTracking') >= 0) || !this.VarTrivBtnTracking.bSCORM)
		this.VarTrivBtnTracking.set(hexString);
}

var trivBtnTracking = new ButtonTrackingObj(365,'inside_media_and_entertainment', 0, 'scorm');
trivBtnTracking.title={id:1,v:0,c:[{id:655155,v:'normalState'},{id:47849,v:'normalState'},{id:50838,v:'normalState'},{id:50845,v:'normalState'},{id:50852,v:'normalState'},{id:50859,v:'normalState'},{id:265103,v:'normalState'},{id:52029,v:'normalState'},{id:58646,v:'normalState'},{id:598617,v:'normalState'},{id:176645,v:'normalState'},{id:293612,v:'normalState'},{id:9201,v:'normalState'},{id:9947,v:'normalState'},{id:575907,v:'normalState'},{id:792169,v:'normalState'},{id:792160,v:'normalState'},{id:1155532,v:'normalState'},{id:1155542,v:'normalState'},{id:1155552,v:'normalState'},{id:1155573,v:'normalState'},{id:1155588,v:'normalState'},{id:1155596,v:'normalState'},{id:1155610,v:'normalState'},{id:720758,v:'normalState'},{id:720746,v:'normalState'},{id:720722,v:'normalState'},{id:720710,v:'normalState'},{id:720698,v:'normalState'},{id:802069,v:'normalState'},{id:1336974,v:'normalState'},{id:1343290,v:'normalState'},{id:1156962,v:'normalState'},{id:1157006,v:'normalState'},{id:1337266,v:'normalState'},{id:1337871,v:'normalState'},{id:1337881,v:'normalState'},{id:1347466,v:'normalState'},{id:1337905,v:'normalState'},{id:1347590,v:'normalState'},{id:1337921,v:'normalState'},{id:1157144,v:'normalState'},{id:1157155,v:'normalState'},{id:1157166,v:'normalState'},{id:1351723,v:'normalState'},{id:1157182,v:'normalState'},{id:1351714,v:'normalState'},{id:1157196,v:'normalState'},{id:1351705,v:'normalState'},{id:1157211,v:'normalState'},{id:1357370,v:'normalState'},{id:1337622,v:'normalState'},{id:1363858,v:'normalState'},{id:1363667,v:'normalState'},{id:1157688,v:'normalState'},{id:1157696,v:'normalState'},{id:1157704,v:'normalState'},{id:1157712,v:'normalState'},{id:1358787,v:'normalState'},{id:1157726,v:'normalState'},{id:1363053,v:'normalState'},{id:1363298,v:'normalState'},{id:1363448,v:'normalState'},{id:1248270,v:'normalState'},{id:1366880,v:'normalState'},{id:1338990,v:'normalState'},{id:1339050,v:'normalState'},{id:1339014,v:'normalState'},{id:1339038,v:'normalState'},{id:1339002,v:'normalState'},{id:1339067,v:'normalState'},{id:1339090,v:'normalState'},{id:1380746,v:'normalState'},{id:1380985,v:'normalState'},{id:1339134,v:'normalState'},{id:1339143,v:'normalState'},{id:1338791,v:'normalState'},{id:1338803,v:'normalState'},{id:1338815,v:'normalState'},{id:1338839,v:'normalState'},{id:1338851,v:'normalState'},{id:1338868,v:'normalState'},{id:1338891,v:'normalState'},{id:1379370,v:'normalState'},{id:1379601,v:'normalState'},{id:1338935,v:'normalState'},{id:1338944,v:'normalState'},{id:1338393,v:'normalState'},{id:1338453,v:'normalState'},{id:1338417,v:'normalState'},{id:1338441,v:'normalState'},{id:1338405,v:'normalState'},{id:1338470,v:'normalState'},{id:1338493,v:'normalState'},{id:1375063,v:'normalState'},{id:1375241,v:'normalState'},{id:1338537,v:'normalState'},{id:1338546,v:'normalState'},{id:1339189,v:'normalState'},{id:1339201,v:'normalState'},{id:1339213,v:'normalState'},{id:1339237,v:'normalState'},{id:1339249,v:'normalState'},{id:1339266,v:'normalState'},{id:1385071,v:'normalState'},{id:1385257,v:'normalState'},{id:1385466,v:'normalState'},{id:1339360,v:'normalState'},{id:1339369,v:'normalState'},{id:1338592,v:'normalState'},{id:1338604,v:'normalState'},{id:1338616,v:'normalState'},{id:1338640,v:'normalState'},{id:1338652,v:'normalState'},{id:1338669,v:'normalState'},{id:1338692,v:'normalState'},{id:1376100,v:'normalState'},{id:1376326,v:'normalState'},{id:1338736,v:'normalState'},{id:1338745,v:'normalState'},{id:1388887,v:'normalState'},{id:1339706,v:'normalState'},{id:1339722,v:'normalState'},{id:1339679,v:'normalState'},{id:1339690,v:'normalState'},{id:1339828,v:'normalState'},{id:1339850,v:'normalState'},{id:1340176,v:'normalState'},{id:1340185,v:'normalState'},{id:1340206,v:'normalState'},{id:1396752,v:'normalState'},{id:1340258,v:'normalState'},{id:1340267,v:'normalState'},{id:1398166,v:'normalState'},{id:1399457,v:'normalState'},{id:1340338,v:'normalState'},{id:1340347,v:'normalState'},{id:1400675,v:'normalState'},{id:1400861,v:'normalState'},{id:1340422,v:'normalState'},{id:1340431,v:'normalState'},{id:1401404,v:'normalState'},{id:1402718,v:'normalState'},{id:1340502,v:'normalState'},{id:1340511,v:'normalState'},{id:1403472,v:'normalState'},{id:1403663,v:'normalState'},{id:937962,v:'normalState'},{id:1340842,v:'normalState'},{id:1340886,v:'normalState'},{id:1407460,v:'normalState'},{id:1407472,v:'normalState'},{id:1407484,v:'normalState'},{id:1407429,v:'normalState'},{id:1407439,v:'normalState'},{id:1407449,v:'normalState'},{id:1337153,v:'normalState'},{id:1409822,v:'normalState'},{id:1409970,v:'normalState'},{id:1341224,v:'normalState'},{id:1341233,v:'normalState'},{id:1341248,v:'normalState'},{id:1341262,v:'normalState'},{id:1413502,v:'normalState'},{id:1413493,v:'normalState'},{id:1413484,v:'normalState'},{id:1413475,v:'normalState'},{id:1414697,v:'normalState'},{id:1415084,v:'normalState'},{id:1415593,v:'normalState'},{id:1415874,v:'normalState'},{id:1437480,v:'normalState'},{id:1341644,v:'normalState'},{id:1341654,v:'normalState'},{id:1341664,v:'normalState'},{id:1341685,v:'normalState'},{id:1341708,v:'normalState'},{id:1341722,v:'normalState'},{id:1341862,v:'normalState'},{id:1341876,v:'normalState'},{id:1341899,v:'normalState'},{id:1341916,v:'normalState'},{id:1341930,v:'normalState'},{id:1341938,v:'normalState'},{id:1341947,v:'normalState'},{id:1341956,v:'normalState'},{id:1341965,v:'normalState'},{id:1341974,v:'normalState'},{id:1160849,v:'normalState'},{id:1160893,v:'normalState'},{id:70221,v:'normalState'},{id:321023,v:'normalState'},{id:321015,v:'normalState'},{id:1025142,v:'normalState'},{id:1025156,v:'normalState'},{id:1025256,v:'normalState'},{id:1025270,v:'normalState'},{id:194542,v:'normalState'},{id:294732,v:'normalState'},{id:1055301,v:'normalState'},{id:1055315,v:'normalState'},{id:323733,v:'normalState'},{id:323725,v:'normalState'},{id:1246226,v:'normalState'},{id:1055444,v:'normalState'},{id:788049,v:'normalState'},{id:788063,v:'normalState'},{id:1246456,v:'normalState'},{id:923590,v:'normalState'},{id:323409,v:'normalState'},{id:323401,v:'normalState'},{id:70100,v:'normalState'},{id:325221,v:'normalState'},{id:325757,v:'normalState'},{id:329044,v:'normalState'},{id:327409,v:'normalState'},{id:625193,v:'normalState'},{id:625135,v:'normalState'},{id:625143,v:'normalState'},{id:625151,v:'normalState'},{id:625159,v:'normalState'},{id:625167,v:'normalState'},{id:233645,v:'normalState'},{id:233637,v:'normalState'},{id:590305,v:'normalState'},{id:590317,v:'normalState'},{id:673002,v:'normalState'},{id:674262,v:'normalState'},{id:590337,v:'normalState'},{id:590345,v:'normalState'},{id:233060,v:'normalState'},{id:233308,v:'normalState'},{id:135253,v:'normalState'},{id:234172,v:'normalState'},{id:233847,v:'normalState'},{id:233839,v:'normalState'},{id:69966,v:'normalState'}]};
